IDEAL
P486
MODEL SMALL
LOCALS @@

        INCLUDE     "DEFS.INC"

        PUBLIC      _COLOR_FLAG
        PUBLIC      _DIST
        PUBLIC      _DISTANCE

DATASEG

        INCLUDE     "TABLES.INC"
        INCLUDE     "MAP.INC"
        _COLOR_FLAG DW  0
        _DIST       DD  INF
        X           DD  0
        Y           DD  0
        XP          DD  0
        YP          DD  0
        X_DIST      DD  0
        Y_DIST      DD  0
        CF1         DW  0
        CF2         DW  0
        ANGLE       DD  0
        A           DD  0

CODESEG

PROC    _DISTANCE   FAR
        MOV         AX,      DGROUP
        MOV         DS,      AX
        MOV         BP,      SP
        MOV         EAX,     [BP + 12]
        SHL         EAX,     M_DIGIT
        MOV         [X],     EAX
        MOV         [XP],    EAX
        MOV         EAX,     [BP + 8]
        SHL         EAX,     M_DIGIT
        MOV         [Y],     EAX
        MOV         [YP],    EAX
        MOV         EBX,     [BP + 4]
        MOV         [ANGLE], EBX
        CMP         EBX,     0
        JNS         @@1
        MOV         ECX,     TABLE_SIZE
        DEC         ECX
        XOR         EAX,     EAX
        SUB         EAX,     EBX
        XOR         EDX,     EDX
        MOV         EBX,     TABLE_SIZE
        DIV         EBX
        SUB         ECX,     EDX
        MOV         [ANGLE], ECX
@@1:    MOV         EAX,     TABLE_SIZE
        DEC         EAX
        CMP         [ANGLE], EAX
        JNA         @@2
        MOV         EAX,     [ANGLE]
        XOR         EDX,     EDX
        MOV         EBX,     TABLE_SIZE
        DIV         EBX
        MOV         [ANGLE], EDX
@@2:    MOV         EAX,     [ANGLE]
        CMP         EAX,     ANGLE_0
        JE          @@3
        CMP         EAX,     ANGLE_180
        JE          @@3
        CMP         EAX,     ANGLE_0
        JNA         @@4
        CMP         EAX,     ANGLE_180
        JNB         @@4
        XOR         EDX,     EDX
        MOV         EAX,     [Y]
        MOV         EBX,     N
        DIV         EBX
        MOV         [YP],    EDX
        MOV         EAX,     EDX
        SHR         EAX,     M_DIGIT
        XOR         EDX,     EDX
        MOV         EBX,     [ANGLE]
        SHL         EBX,     2
        MOV         EBX,     [CTN_TABLE + BX]
        IMUL        EBX
        ADD         [XP],    EAX
        MOV         EAX,     [Y]
        SUB         EAX,     [YP]
        MOV         [YP],    EAX
        XOR         ECX,     ECX
        SUB         ECX,     N
        MOV         [A],     -1
        JMP         @@5
@@4:    XOR         EDX,     EDX
        MOV         EAX,     [Y]
        MOV         EBX,     N
        DIV         EBX
        SUB         EBX,     EDX
        MOV         [YP],    EBX
        MOV         EAX,     [YP]
        SHR         EAX,     M_DIGIT
        XOR         EDX,     EDX
        MOV         EBX,     [ANGLE]
        SHL         EBX,     2
        MOV         EBX,     [CTN_TABLE + BX]
        IMUL        EBX
        SUB         [XP],    EAX
        MOV         EAX,     [Y]
        ADD         [YP],    EAX
        MOV         ECX,     N
        MOV         [CF1],   1
@@5:    MOV         EAX,     [YP]
        SHR         EAX,     N_DIGIT
        ADD         EAX,     [A]
        XOR         EDX,     EDX
        MOV         EBX,     MAP_SIZE
        IMUL        EBX
        MOV         EBX,     EAX
        MOV         EAX,     [XP]
        SHR         EAX,     N_DIGIT
        ADD         EBX,     EAX
        MOV         BL,      [MAP + BX]
        AND         EBX,     0FFH
        AND         EBX,     [XP]
        MOV         EAX,     [XP]
        CMP         EAX,     MAP_SIZE
        JNB         @@6
        XOR         EBX,     EBX
@@6:    CMP         EBX,     0
        JZ          @@7
        ADD         [YP],    ECX
        MOV         EAX,     ECX
        SHR         EAX,     M_DIGIT
        XOR         EDX,     EDX
        MOV         EBX,     [ANGLE]
        SHL         EBX,     2
        MOV         EBX,     [CTN_TABLE + BX]
        IMUL        EBX
        SUB         [XP],    EAX
        JMP         @@5
@@7:    MOV         EBX,     [ANGLE]
        SHL         EBX,     2
        MOV         EBX,     [COS_TABLE + BX]
        CMP         EBX,     0
        JNZ         @@8
        MOV         EAX,     [YP]
        SUB         EAX,     [Y]
        SHR         EAX,     M_DIGIT
        MOV         [X_DIST],EAX
        JMP         @@9
@@8:    MOV         EAX,     [XP]
        SUB         EAX,     [X]
        XOR         EDX,     EDX
        IDIV        EBX
        MOV         [X_DIST],EAX
@@9:    CMP         [X_DIST],0
        JNS         @@10
        XOR         EAX,     EAX
        SUB         EAX,     [X_DIST]
        MOV         [X_DIST],EAX
@@3:    MOV         [X_DIST],INF
@@10:   MOV         EAX,     [X]
        MOV         [XP],    EAX
        MOV         EAX,     [Y]
        MOV         [YP],    EAX
        MOV         EAX,     [ANGLE]
        CMP         EAX,     ANGLE_90
        JE          @@11
        CMP         EAX,     ANGLE_270
        JE          @@11
        CMP         EAX,     ANGLE_90
        JNA         @@12
        CMP         EAX,     ANGLE_270
        JNB         @@12
        MOV         EAX,     [X]
        XOR         EDX,     EDX
        MOV         EBX,     N
        DIV         EBX
        MOV         [XP],    EDX
        MOV         EAX,     EDX
        SHR         EAX,     M_DIGIT
        XOR         EDX,     EDX
        MOV         EBX,     [ANGLE]
        SHL         EBX,     2
        MOV         EBX,     [TAN_TABLE + BX]
        IMUL        EBX
        ADD         [YP],    EAX
        MOV         EAX,     [X]
        SUB         EAX,     [XP]
        MOV         [XP],    EAX
        XOR         ECX,     ECX
        SUB         ECX,     N
        MOV         [A],     -1
        JMP         @@13
@@12:   MOV         EAX,     [X]
        XOR         EDX,     EDX
        MOV         EBX,     N
        DIV         EBX
        SUB         EBX,     EAX
        MOV         [XP],    EBX
        MOV         EAX,     [XP]
        SHR         EAX,     M_DIGIT
        XOR         EDX,     EDX
        MOV         EBX,     [ANGLE]
        SHL         EBX,     2
        MOV         EBX,     [TAN_TABLE + BX]
        IMUL        EBX
        SUB         [YP],    EAX
        MOV         EAX,     [X]
        ADD         [XP],    EAX
        MOV         ECX,     N
        MOV         [CF2],   1
@@13:   MOV         EAX,     [YP]
        SHR         EAX,     N_DIGIT
        XOR         EDX,     EDX
        MOV         EBX,     MAP_SIZE
        MUL         EBX
        MOV         EBX,     EAX
        MOV         EAX,     [XP]
        SHR         EAX,     N_DIGIT
        ADD         EAX,     [A]
        ADD         EBX,     EAX
        MOV         BL,      [MAP + BX]
        AND         EBX,     0FFH
        MOV         EAX,     [YP]
        AND         EBX,     EAX
        CMP         EAX,     MAP_SIZE
        JB          @@14
        XOR         EBX,     EBX
@@14:   CMP         EBX,     0
        JZ          @@15
        ADD         [XP],    ECX
        MOV         EAX,     ECX
        SHR         EAX,     M_DIGIT
        XOR         EDX,     EDX
        MOV         EBX,     [ANGLE]
        SHL         EBX,     2
        MOV         EBX,     [TAN_TABLE + BX]
        IMUL        EBX
        SUB         [YP],    EAX
        JMP         @@13
@@15:   MOV         EBX,     [ANGLE]
        SHL         EBX,     2
        MOV         EBX,     [SIN_TABLE + BX]
        CMP         EBX,     0
        JNZ         @@16
        MOV         EAX,     [XP]
        SUB         EAX,     [X]
        SHR         EAX,     M_DIGIT
        MOV         [Y_DIST],EAX
        JMP         @@17
@@16:   MOV         EAX,     [YP]
        SUB         EAX,     [Y]
        XOR         EDX,     EDX
        IDIV        EBX
        MOV         [Y_DIST],EAX
@@17:   CMP         [Y_DIST],0
        JNZ         @@18
        XOR         EAX,     EAX
        SUB         EAX,     [Y_DIST]
        MOV         [Y_DIST],EAX
@@11:   MOV         [Y_DIST],INF
@@18:   MOV         EAX,     [Y_DIST]
        CMP         EAX,     [X_DIST]
        JNB         @@19
        MOV         AX,      [CF2]
        ADD         AX,      2
        MOV         [_COLOR_FLAG],AX
        MOV         EAX,     [Y_DIST]
        MOV         EDX,     EAX
        SHR         EDX,     16
        AND         EAX,     0FFFFH
        RET
@@19:   CMP         EAX,     [X_DIST]
        JE          @@20
        MOV         AX,      [CF1]
        MOV         [_COLOR_FLAG],AX
        MOV         EAX,     [X_DIST]
        MOV         EDX,     EAX
        SHR         EDX,     16
        AND         EAX,     0FFFFH
        RET
@@20:   MOV         EAX,     [_DIST]
        MOV         EDX,     EAX
        SHR         EDX,     16
        AND         EAX,     0FFFFH
        RET
ENDP    _DISTANCE

END
